com.sap.conn.jco.monitor

## Interface JCoDestinationMonitor

-     public interface JCoDestinationMonitor

  The destination monitor provides runtime details about a destination. The monitor instance will be created by `JCoDestination.getMonitor()` or by `JCo.getDestinationMonitor(id)`, where `id` is a value of `JCo.getDestinationIDs()`.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<? extends JCoConnectionData>` | `getConnectionsData()` Creates and returns a list of all client connections that are currently used with or held open by the monitored destination instance.
    `String` | `getDestinationID()` Returns the ID of the destination instance that is monitored by this instance.
    `String` | `getDestinationName()` Returns the name of the destination configuration which the monitored destination instance was created from.
    `long` | `getLastActivityTimestamp()` Returns the time stamp of the last activity done with the monitored destination instance.
    `int` | `getMaxUsedCount()` Returns the maximum number of simultaneously used client connections with the monitored destination instance.
    `String` | `getOriginDestinationID()` Returns the ID of the destination instance that the monitored destination instance originated from.
    `int` | `getPeakLimit()` Returns the maximum number of client connections that can be used simultaneously with the monitored destination instance.
    `int` | `getPoolCapacity()` Returns the maximum number of client connections that will be held open for the monitored destination instance.
    `int` | `getPooledConnectionCount()` Returns the number of client connections that are currently held open for the monitored destination instance.
    `int` | `getUsedConnectionCount()` Returns the number of client connections that are currently being used with the monitored destination instance.
    `int` | `getWaitingThreadCount()` Returns the number of threads that are currently waiting for a free connection to be used with the monitored destination instance.
    `boolean` | `isValid()` Returns `true` if the monitored destination instance is valid, i.e.

- - ### Method Detail

    - #### getDestinationID

          String getDestinationID()

      Returns the ID of the destination instance that is monitored by this instance.
      Returns:
        destination ID as string

    - #### getOriginDestinationID

          String getOriginDestinationID()

      Returns the ID of the destination instance that the monitored destination instance originated from. This is relevant if monitoring a `JCoCustomDestination` instance. In case of monitoring a configured destination instance, it will return `null`.
      Returns:
        origin destination ID as string or `null`

    - #### getDestinationName

          String getDestinationName()

      Returns the name of the destination configuration which the monitored destination instance was created from.
      Returns:
        the destination name
      Since:
        JCo 3.0.16

    - #### getPoolCapacity

          int getPoolCapacity()

      Returns the maximum number of client connections that will be held open for the monitored destination instance.
      Returns:
        the size of the associated client connection pool
      Throws:
        `JCoRuntimeException` - with key `JCO_ERROR_DESTINATION_DATA_INVALID` if the monitored destination instance is invalid

    - #### getPeakLimit

          int getPeakLimit()

      Returns the maximum number of client connections that can be used simultaneously with the monitored destination instance.
      Returns:
        the peak limit of the associated client connection pool
      Throws:
        `JCoRuntimeException` - with key `JCO_ERROR_DESTINATION_DATA_INVALID` if the monitored destination instance is invalid

    - #### getUsedConnectionCount

          int getUsedConnectionCount()

      Returns the number of client connections that are currently being used with the monitored destination instance.
      Returns:
        the number of currently used client connections
      Throws:
        `JCoRuntimeException` - with key `JCO_ERROR_DESTINATION_DATA_INVALID` if the monitored destination instance is invalid

    - #### getPooledConnectionCount

          int getPooledConnectionCount()

      Returns the number of client connections that are currently held open for the monitored destination instance.
      Returns:
        the number of currently held open client connections by the associated client connection pool
      Throws:
        `JCoRuntimeException` - with key `JCO_ERROR_DESTINATION_DATA_INVALID` if the monitored destination instance is invalid

    - #### getMaxUsedCount

          int getMaxUsedCount()

      Returns the maximum number of simultaneously used client connections with the monitored destination instance.
      Returns:
        the maximum number of client connections that have been used simultaneously
      Throws:
        `JCoRuntimeException` - with key `JCO_ERROR_DESTINATION_DATA_INVALID` if the monitored destination instance is invalid

    - #### getWaitingThreadCount

          int getWaitingThreadCount()

      Returns the number of threads that are currently waiting for a free connection to be used with the monitored destination instance.
      Returns:
        the number of threads that are currently waiting for a connection to get from the associated client connection pool
      Throws:
        `JCoRuntimeException` - with key `JCO_ERROR_DESTINATION_DATA_INVALID` if the monitored destination instance is invalid
      Since:
        JCo 3.0.9

    - #### getLastActivityTimestamp

          long getLastActivityTimestamp()

      Returns the time stamp of the last activity done with the monitored destination instance.
      Returns:
        the last activity time stamp in ms
      Throws:
        `JCoRuntimeException` - with key `JCO_ERROR_DESTINATION_DATA_INVALID` if the monitored destination instance is invalid

    - #### getConnectionsData

          List<? extends JCoConnectionData> getConnectionsData()

      Creates and returns a list of all client connections that are currently used with or held open by the monitored destination instance.
      Returns:
        a list of `JCoConnectionData` objects describing all open client connections
      Throws:
        `JCoRuntimeException` - with key `JCO_ERROR_DESTINATION_DATA_INVALID` if the monitored destination instance is invalid

    - #### isValid

          boolean isValid()

      Returns `true` if the monitored destination instance is valid, i.e. it has neither been changed nor removed.
      Returns:
        `true` if the monitored destination instance is valid; `false` otherwise
      Since:
        JCo 3.0.8

Copyright © 2018 SAP. All Rights Reserved.